--************************************************************************
--* TOOL : Unit Test Compiler VERSION 2002.05.21.468.004                 *
--*                                                                      *
--* COMMAND : attolprepro H:\support\BaeSystems\v182333229\calc.ptu      *
--*   adapcgnt\TCalc.ada /LANGUAGE=ADA /TARGET=PC/NT /FAST               *
--*   /NOSIMULATION                                                      *
--*   /STANDARD=C:\PROGRA~1\Rational\TESTRE~1\targets\adapcgnt\ana\ada95.alk  *
--*   /ADALINK=adalink.alk                                               *
--*                                                                      *
--* FILE : adapcgnt\TCalc_var_simule_B.ada                               *
--*                                                                      *
--* DATE : Mon Apr 28 17:39:57 2003                                      *
--************************************************************************
With Unchecked_Conversion;

Package body TCalc_var_simule Is

  Procedure Init2(N : IN Standard.Integer; Variant : In Standard.Integer; X : IN OUT STANDARD.INTEGER; Value : IN
 STANDARD.INTEGER) Is
  Begin
    Case Variant Is -- Variant on 'X'
      When 1 =>
        X := Value;
        Attol.Ptu_Ada(Attol.Attol_big_int(X),N,10);
      When Others =>
        Null;
    End Case; -- Variant on 'X'
  Exception
    When Others =>
      Attol.Excep_ada(1);
  End; -- Procedure Init2(STANDARD.INTEGER)

  Procedure Edp2(N : IN Standard.Integer; Mode_Check : In Attol.ModeCheck; Mode_Valid : In Attol.ModeValid;
                Variant : In Standard.Integer; X : IN STANDARD.INTEGER; Min : IN STANDARD.INTEGER;
                Max : IN STANDARD.INTEGER) Is
  Begin
    If (Attol."="(Mode_Valid,Attol.StdValue)) Then
      Case Variant Is -- Variant on 'X'
        When 0 =>
          Null;
        When Others =>
          Attol.Edv_Ada(Mode_Check,Attol.Attol_big_int(X),Attol.Attol_int(N),Attol.Attol_big_int(Min)
,Attol.Attol_big_int(Max),10,Mode_Valid);
      End Case; -- Variant on 'X'
    Else
      Case Variant Is -- Variant on 'X'
        When 0 =>
          Null;
        When Others =>
          Attol.Edv_Ada(Mode_Check,Attol.Attol_big_int(X),Attol.Attol_int(N),Attol.Attol_big_int(Min)
,Attol.Attol_big_int(Max),10,Mode_Valid);
      End Case; -- Variant on 'X'
    End if; -- Mode_Valid
  Exception
    When Others =>
      Attol.Erv_ada(Attol.Attol_int(N));
  End; -- Procedure Edp2(STANDARD.INTEGER)

  Procedure Edp2_1(N : IN Standard.Integer; Mode_Check : In Attol.ModeCheck;
                Variant : In Standard.Integer; X : IN STANDARD.INTEGER; Ev : IN STANDARD.INTEGER) Is
  Begin -- only here to avoid some nasty sideboard effect
    Edp2(N,Mode_Check,Attol.StdValue,Variant,X,Ev,Ev);
  End; -- Procedure Edp2_1(STANDARD.INTEGER)

  Procedure Check_in2(X : IN STANDARD.INTEGER; Min : IN STANDARD.INTEGER;
                     Max : IN STANDARD.INTEGER; Error : IN OUT Attol.Attol_int; Variant : In Standard.Integer) Is
  Begin
    If (Error = 0) Then
      Case Variant Is -- Variant on 'X'
        When 1 =>
          If X Not In Min..Max Then
            Error := 1;
          End If; -- X Not In Min..Max
        When Others =>
          Null;
      End Case; -- Variant on X
    End if; -- Error = 0
  Exception
    When Others =>
      Attol.Excep_ada(8);
      Error := 1;
  End; -- Procedure Check_in2(STANDARD.INTEGER)

  Procedure Edp1(N : IN Standard.Integer; Mode_Check : In Attol.ModeCheck; Mode_Valid : In Attol.ModeValid;
                Variant : In Standard.Integer; X : IN INTERFACE.DATA_ARRAY; Min : IN INTERFACE.DATA_ARRAY;
                Max : IN INTERFACE.DATA_ARRAY) Is
  Begin
    Attol.Set_Mode_Tab_Ada(Attol.Attol_Int(N),Attol.Attol_Int(1));
    Begin -- array bloc
      For I1 In X'First(1)..X'Last(1) Loop
        Attol.Attol_bcl(1,STANDARD.INTEGER'POS(I1));
        If ((Attol."="(Mode_Valid,Attol.StdValue))
             And Then (I1 In Min'First(1)..Min'Last(1))
             And Then (I1 In Max'First(1)..Max'Last(1))
             ) Then
          Case Variant Is -- Variant on 'X(I1)'
            When 1 =>
              TCalc_var_simule.Edp2(STANDARD.INTEGER'POS(I1),Mode_Check,Mode_Valid,1,X(I1),Min(I1),Max(I1));
            When Others =>
              Null;
          End Case; -- Variant on 'X(I1)'
        Else
          Case Variant Is -- Variant on 'X(I1)'
            When 1 =>
              TCalc_var_simule.Edp2(STANDARD.INTEGER'POS(I1),Mode_Check,Attol.BadValue,1,X(I1),X(I1),X(I1));
            When Others =>
              Null;
          End Case; -- Variant on 'X(I1)'
        End if; -- Local_Mode_Valid = Attol.StdValue
      End Loop; -- For I1
    Exception
      When Others =>
        Attol.Erv_ada(Attol.Attol_int(N));
    End; -- array bloc
    Attol.Unset_Mode_Tab_Ada(Attol.Attol_Int(N),Attol.Attol_Int(1));
  Exception
    When Others =>
      Attol.Erv_ada(Attol.Attol_int(N));
  End; -- Procedure Edp1(INTERFACE.DATA_ARRAY)

  Procedure Check_in1(X : IN INTERFACE.DATA_ARRAY; Min : IN INTERFACE.DATA_ARRAY;
                     Max : IN INTERFACE.DATA_ARRAY; Error : IN OUT Attol.Attol_int; Variant : In Standard.Integer) Is
  Begin
    If (Error = 0) Then
      Attol_Bcl:
      For I1 In X'First(1)..X'Last(1) Loop
        Case Variant Is -- Variant on 'X(I1)'
          When 1 =>
            TCalc_var_simule.Check_in2(X(I1),Min(I1),Max(I1),Error,1);
          When Others =>
            Null;
        End Case; -- Variant on 'X(I1)'
        Exit Attol_Bcl When (Error = 1);
      End Loop Attol_Bcl; -- For I1
    End if; -- Error = 0
  Exception
    When Others =>
      Attol.Excep_ada(8);
      Error := 1;
  End; -- Procedure Check_in1(INTERFACE.DATA_ARRAY)

  Package body Att_1 Is
    Package body Att_1_SEND Is
      procedure Check is
        Package Attol_f renames TCalc_var_simule.Att_1.Att_1_SEND;
        Attol_Error : Attol.Attol_int := 0;
        Attol_Pos   : Attol.Attol_int := -1;
      Begin
        Attol.Begin_Check_Stub(1,Attol_f.Slicerange,Attol_f.Idx);
        If Standard.">"(Attol_f.Cpt_Err,10) then
          Attol_f.Cpt_Err := 10;
        End if; -- Attol_f.Cpt_Err > 10
        for I in Attol.Attol_Int range 1..Attol_f.Cpt_Err loop
          declare
            Attol_Err : Attol_f.Slice_Err renames Attol_f.Err(I);
          begin
            Attol.Edv_Muet_Check(1,Attol_Err.Index);
            Attol.Searchpos(Attol_Err.Index,Attol_f.Slicerange,Attol_Error,Attol_Pos);
            declare
              Attol_Args : Attol_f.Field renames Attol_f.Tabfield(Attol_Pos);
            begin
              TCalc_var_simule.Edp1(1,Attol.Check,Attol.StdValue,1,Attol_Err.Field.DATA,Attol_Args.Min.DATA
,Attol_Args.Max.DATA);
            end; -- declare
          end; -- declare
        end loop; -- for
      Exception
        when others =>
          Attol.Excep_Ada(8);
      end Check;

      Procedure Init is
        Package Attol_f renames TCalc_var_simule.Att_1.Att_1_SEND;
      begin
        Attol_f.Idx := 0;
        Attol_f.Cpt_err := 0;
        Attol_f.Slicerange := (Others => Attol.Slice_Muet'(0,0));
      Exception
        When Others =>
          Attol.Excep_Ada(1);
      End Init;

    End; -- Package Att_1_SEND
  End; -- Package body Att_INTERFACE

  Procedure Check_All is
  Begin
    TCalc_var_simule.Att_1.Att_1_SEND.Check;
    Attol.Edv_Muet_Check(0,0);
  End; -- Procedure Check_All

  Procedure Init_All is
  Begin
    TCalc_var_simule.Att_1.Att_1_SEND.Init;
    Null;
  End; -- Procedure Check_All

End; -- Package body TCalc_var_simule
