-- Add with clauses 
with text_io;
package private_io is
	subtype INTEGER_32B is integer;
	subtype LONGEST_INTEGER is long_long_integer;
	subtype LONGEST_FLOAT is long_float;
	subtype PRIV_FILE is text_io.file_type;
	string_max_len:Constant:=100;
	access_size:Constant:=32;
	access_min:Constant:=0;
	access_max:Constant:=(2**(access_size))-1;
	atc_nb_bit_branch:Constant Integer:=31;
	clock_offset:Constant:=0;
	clock_multiply:Constant:=1;
	clock_divide:Constant:=1;
	clock_unit:Constant String:="D0 ";
	atc_tio_file_name:Constant String:="attolcov.tio";
	subtype priv_int is Integer_32b;
	function priv_clock return priv_int;
	procedure priv_open(file : in out priv_file; name : in string );
	procedure priv_writeln(file : in out priv_file; line: in string);
	procedure priv_close(file : in out priv_file);
	procedure priv_date(date_sys:out string;lg_date :out integer);
-- Give functions specifications

end private_io;
